Đến nội dung


Hình ảnh
- - - - -

lisp đổi font của text style siêu nhanh !


  • Please log in to reply
18 replies to this topic

#1 hanam1210

hanam1210

    biết vẽ pline

  • Members
  • PipPip
  • 61 Bài viết
Điểm đánh giá: 1 (bình thường)

Đã gửi 09 September 2011 - 08:45 AM

Em hay phải chỉnh sửa bản vẽ cho chuẩn ISO, hay phải chỉnh font của text style. Em đang cần 1 lisp làm nhiệm vụ như sau. Khi e đánh lệnh và tích vào 1 text thuộc 1 style nào đó. Thì font của style đó được chuyển sang font .VNAVANTH (chế độ regular). Mong các bác biết về lisp giúp đỡ em ạ !
  • 0

#2 cd2k44

cd2k44

    Edu level: li5

  • Members
  • PipPipPipPipPipPipPip
  • 648 Bài viết
Điểm đánh giá: 121 (tàm tạm)

Đã gửi 09 September 2011 - 09:36 AM

Nếu các textstyle kia của ban không đánh theo font TCVN thì khi bạn chuyển Font bạn sẽ bị lỗi.Đã có tool chuyển font chữ.Bạn search là có đó
  • 1

#3 hanam1210

hanam1210

    biết vẽ pline

  • Members
  • PipPip
  • 61 Bài viết
Điểm đánh giá: 1 (bình thường)

Đã gửi 09 September 2011 - 10:41 AM

Nếu các textstyle kia của ban không đánh theo font TCVN thì khi bạn chuyển Font bạn sẽ bị lỗi.Đã có tool chuyển font chữ.Bạn search là có đó

Vâng. Nhưng đây là trường hợp các text được đánh theo font TCVN.
  • 0

#4 cd2k44

cd2k44

    Edu level: li5

  • Members
  • PipPipPipPipPipPipPip
  • 648 Bài viết
Điểm đánh giá: 121 (tàm tạm)

Đã gửi 09 September 2011 - 03:47 PM

Gửi bạn,hy vọng đúng ý bạn

;free lisp by cadviet,cd2k44
;link bai viet http://www.cadviet.com/forum/index.php?showtopic=53830
(defun c:FTEXT (/ ent tstyle )
(command "undo" "be")
(setq ent (entsel "\n Pick text :"))
(setq TSTYLE (cdr (assoc 7 (entget (car ent)))))
(command "STYLE" TSTYLE ".vnavanth" "0" "1" "0" "N" "N")
(setvar "TEXTSTYLE" Tstyle)
(command "undo" "end")
)

  • 0

#5 hanam1210

hanam1210

    biết vẽ pline

  • Members
  • PipPip
  • 61 Bài viết
Điểm đánh giá: 1 (bình thường)

Đã gửi 10 September 2011 - 07:11 AM

Cảm ơn bác CD2K44 nhé. Lisp chuẩn theo yêu cầu rồi ạ. Nhưng khi e muốn tự tạo sang 1 code khác để đổi sang loại font .vntimeh.shx thì ko được nhỉ ? hì. bác xem giúp em xem lỗi ở chỗ nào nhé :



(defun c:FH (/ ent tstyle )
(command "undo" "be")
(setq ent (entsel "\n Pick text :"))
(setq TSTYLE (cdr (assoc 7 (entget (car ent)))))
(command "STYLE" TSTYLE ".vntimeh.shx" "0" "1" "0" "N" "N")
(setvar "TEXTSTYLE" Tstyle)
(command "undo" "end")
)

  • 0

#6 Doan Van Ha

Doan Van Ha

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 5447 Bài viết
Điểm đánh giá: 2624 (tuyệt vời)

Đã gửi 10 September 2011 - 08:30 AM

Cảm ơn bác CD2K44 nhé. Lisp chuẩn theo yêu cầu rồi ạ. Nhưng khi e muốn tự tạo sang 1 code khác để đổi sang loại font .vntimeh.shx thì ko được nhỉ ? hì. bác xem giúp em xem lỗi ở chỗ nào nhé :



(defun c:FH (/ ent tstyle )
(command "undo" "be")
(setq ent (entsel "\n Pick text :"))
(setq TSTYLE (cdr (assoc 7 (entget (car ent)))))
(command "STYLE" TSTYLE ".vntimeh.shx" "0" "1" "0" "N" "N")
(setvar "TEXTSTYLE" Tstyle)
(command "undo" "end")
)

Bạn sửa (command "STYLE" TSTYLE ".vntimeh.shx" "0" "1" "0" "N" "N") thành (command "STYLE" TSTYLE ".vntimeh" "0" "1" "0" "N" "N")
  • 0

* Chỉ nên yêu cầu Lisp khi bạn làm việc đó mất cả ngày nhưng họ chỉ viết 1 giờ. Đừng nêu yêu cầu Lisp khi bạn chỉ làm 1 giờ nhưng bắt họ phải mất cả ngày.

* Nhờ viết lisp cũng như đi khám bệnh. Chỉ gởi căn cước và than sắp chết thì không bác sỹ nào cứu sống được.


#7 hanam1210

hanam1210

    biết vẽ pline

  • Members
  • PipPip
  • 61 Bài viết
Điểm đánh giá: 1 (bình thường)

Đã gửi 10 September 2011 - 08:41 AM

Bạn sửa (command "STYLE" TSTYLE ".vntimeh.shx" "0" "1" "0" "N" "N") thành (command "STYLE" TSTYLE ".vntimeh" "0" "1" "0" "N" "N")

hic. Bác Hà hiểu nhầm rồi. Font .vntimeH.SHX cơ ạ !
  • 0

#8 Doan Van Ha

Doan Van Ha

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 5447 Bài viết
Điểm đánh giá: 2624 (tuyệt vời)

Đã gửi 10 September 2011 - 09:13 AM

hic. Bác Hà hiểu nhầm rồi. Font .vntimeH.SHX cơ ạ !

Thì sửa (command "STYLE" TSTYLE ".vntimeh.shx" "0" "1" "0" "N" "N") thành (command "STYLE" TSTYLE ".vntimeh.shx" "0" "1" "0" "N" "N" "N")
  • 0

* Chỉ nên yêu cầu Lisp khi bạn làm việc đó mất cả ngày nhưng họ chỉ viết 1 giờ. Đừng nêu yêu cầu Lisp khi bạn chỉ làm 1 giờ nhưng bắt họ phải mất cả ngày.

* Nhờ viết lisp cũng như đi khám bệnh. Chỉ gởi căn cước và than sắp chết thì không bác sỹ nào cứu sống được.


#9 hanam1210

hanam1210

    biết vẽ pline

  • Members
  • PipPip
  • 61 Bài viết
Điểm đánh giá: 1 (bình thường)

Đã gửi 10 September 2011 - 09:45 AM

Thì sửa (command "STYLE" TSTYLE ".vntimeh.shx" "0" "1" "0" "N" "N") thành (command "STYLE" TSTYLE ".vntimeh.shx" "0" "1" "0" "N" "N" "N")

hic. Nó mà đơn giản thế thì e đã làm được ạ ? E đổi ngay từ đầu thành như thế nhưng nó ko chạy đc ạ ? hic. Nhưng e đã làm đc rùi. Phải sửa thành
(command "STYLE" TSTYLE ""vntimeh.shx,vns.shx"" "0" "1" "0" "N" "N" "N")
Thanks bác nhé !
  • 0

#10 NvThanh

NvThanh

    biết zoom

  • Members
  • Pip
  • 15 Bài viết
Điểm đánh giá: 1 (bình thường)

Đã gửi 10 September 2011 - 02:58 PM

hic. Nó mà đơn giản thế thì e đã làm được ạ ? E đổi ngay từ đầu thành như thế nhưng nó ko chạy đc ạ ? hic. Nhưng e đã làm đc rùi. Phải sửa thành
(command "STYLE" TSTYLE ""vntimeh.shx,vns.shx"" "0" "1" "0" "N" "N" "N")
Thanks bác nhé !

Cả 2 cách trên đều không đúng thì phải, mình đã thử cách này thì ok .

;; free lisp from cadviet.com
;;; this lisp was downloaded from http://www.cadviet.com/forum/index.php?showtopic=53830&pid=167735&st=0&#entry167735
;free lisp by cadviet,cd2k44
;link bai viet http://www.cadviet.com/forum/index.php?showtopic=53830
(defun c:FT (/ ent tstyle )
(command "undo" "be")
(setq ent (entsel "\n Pick text :"))
(setq TSTYLE (cdr (assoc 7 (entget (car ent)))))
(command "STYLE" TSTYLE "vntimeh.shx,vns.shx" "0" "1" "0" "N" "N" "N")
(setvar "TEXTSTYLE" Tstyle)
(command "undo" "end")
)
bác nào biết thêm tùy chọn tìm và thay thế toàn bộ font trong 1 file cad thành font .vntimeh.shx thì tốt quá
Cảm ơn nhiều !

Bài viết đã được chỉnh sửa nội dung bởi NvThanh: 10 September 2011 - 03:04 PM

  • 0

#11 phamthanhbinh

phamthanhbinh

    biết lệnh adcenter

  • Moderator
  • PipPipPipPipPipPipPip
  • 6007 Bài viết
Điểm đánh giá: 3113 (tuyệt vời)

Đã gửi 10 September 2011 - 05:40 PM

Cả 2 cách trên đều không đúng thì phải, mình đã thử cách này thì ok .


;; free lisp from cadviet.com
;;; this lisp was downloaded from http://www.cadviet.com/forum/index.php?showtopic=53830&pid=167735&st=0&#entry167735
;free lisp by cadviet,cd2k44
;link bai viet http://www.cadviet.com/forum/index.php?showtopic=53830
(defun c:FT (/ ent tstyle )
(command "undo" "be")
(setq ent (entsel "\n Pick text :"))
(setq TSTYLE (cdr (assoc 7 (entget (car ent)))))
(command "STYLE" TSTYLE "vntimeh.shx,vns.shx" "0" "1" "0" "N" "N" "N")
(setvar "TEXTSTYLE" Tstyle)
(command "undo" "end")
)
bác nào biết thêm tùy chọn tìm và thay thế toàn bộ font trong 1 file cad thành font .vntimeh.shx thì tốt quá
Cảm ơn nhiều !

Hề hề hề,
Bạn thử làm thế này xem sao nhé:
1/- Vô hiệu hóa dòng code (setq ent (entsel "\n Pick text :")) bằng cách thêm một vài dấu ; phía trước nó.
2/- Thêm vào dưới dòng code này đoạn code như sau:
(setq sst (acet-ss-to-list (ssget "x" (cons 0 "TEXT,MTEXT"))))
(foreach ent sst
3/- Thêm một dấu ngoặc đóng hàm foreach vào dưới dòng code: (setvar "TEXTSTYLE" Tstyle)

Sau đó load lại lisp và chạy thử xem có được như ý bạn muốn không nhé.
Hề hề hề,.....
Chúc bạn vui.
  • 1
Chúc các quý Anh trên diễn đàn luôn khỏe, đẻ thêm được nhiều thứ để mót.

#12 master_worse

master_worse

    biết lệnh offset

  • Advance Member
  • PipPipPip
  • 170 Bài viết
Điểm đánh giá: 87 (tàm tạm)

Đã gửi 10 September 2011 - 08:36 PM

Em hay phải chỉnh sửa bản vẽ cho chuẩn ISO, hay phải chỉnh font của text style. Em đang cần 1 lisp làm nhiệm vụ như sau. Khi e đánh lệnh và tích vào 1 text thuộc 1 style nào đó. Thì font của style đó được chuyển sang font .VNAVANTH (chế độ regular). Mong các bác biết về lisp giúp đỡ em ạ !


Nếu bạn còn cần, thì thử cái này xem


(defun c:TENLENH (/ text style ename asslst) ;; sua lai ten lenh
(setq text (entsel "\nPick a text or Mtext"))
(setq style (cdr (assoc 7 (entget (car text)))))
(setq ename (tblobjname "style" style))
(setq asslst (entget ename))
(entmod (subst (cons 3 "FONT-MOI") (assoc 3 asslst) asslst)) ;; sua lai font
(command "_.regen")
(princ)
) ;_ end defun

  • 0

Ngu dốt không đáng thẹn bằng thiếu ý chí học hỏi


Tri thức làm người ta khiêm tốn, ngu si làm người ta kiêu ngạo (Ngạn ngữ Anh)


#13 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5678 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 10 September 2011 - 09:46 PM

@hanam1210 : nếu lần tới bạn lập topic mới trong box Autolisp về 1 vấn đề ĐÃ CÓKHÔNG TUÂN THEO NỘI QUY thì bài viết sẽ được chuyển vào thùng rác, mong bạn thông cảm và rút kinh nghiệm nhé. Have fun ^^
  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#14 AutoTay.com

AutoTay.com

    biết lệnh move

  • Members
  • PipPipPip
  • 125 Bài viết
Điểm đánh giá: 19 (tàm tạm)

Đã gửi 11 October 2011 - 05:38 PM

Chào các bác!
Theo em thử thì các lisp trên dùng để thay đổi Textsyle của tất cả các Text có cùng Textstyle với Text mình chọn phải không ạ?
Các bác viết dùm em 1 lisp chỉ thay đổi Textstyle của Text mình chọn với ạ!
Thank các bác nhiều!
  • 0

#15 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5678 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 11 October 2011 - 07:56 PM

Chào các bác!
Theo em thử thì các lisp trên dùng để thay đổi Textsyle của tất cả các Text có cùng Textstyle với Text mình chọn phải không ạ?
Các bác viết dùm em 1 lisp chỉ thay đổi Textstyle của Text mình chọn với ạ!
Thank các bác nhiều!

Chọn text => Ctrl + 1 => Đổi style trong bảng Properties.
Ngoài ra cũng phải nói thêm là lisp bạn hỏi chắc chắc đã có
  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#16 TÀO NGU

TÀO NGU

    biết pan

  • Members
  • Pip
  • 7 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 11 May 2012 - 05:33 PM

Nhờ các cao thủ giúp cho lisp chuyển style text sang kiểu Arial. Xin cảm ơn các bác!
  • 0

#17 pphung183

pphung183

    biết dimstyle

  • Members
  • PipPipPipPipPip
  • 384 Bài viết
Điểm đánh giá: 425 (tốt)

Đã gửi 28 February 2014 - 08:54 PM

http://www.cadviet.c...127397_fixa.lsp


  • 1

#18 nghau90

nghau90

    biết vẽ circle

  • Members
  • PipPip
  • 32 Bài viết
Điểm đánh giá: -1 (bình thường)

Đã gửi 07 November 2014 - 10:07 AM

các bác giúp ké, e cần thay đổi toàn bộ font  của dim về cùng một font . thanks các b


  • 0

#19 huyenle

huyenle

    biết zoom

  • Members
  • Pip
  • 14 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 26 June 2016 - 01:33 PM

Bạn có thể chỉ giúp mình thay style text thành bold trong lisp được không? hình như là đangở chế độ regular. Thanks


  • 0